#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK4x64x64TT4x4x64_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=4, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=64, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + (((lda) << 2));
   const float *stN = B + 64;
   const float *pfA = A + M;
   #define incAk 64
   const int incAm = ((((lda) << 2)) - 64), incAn = -(((lda) << 2));
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 4
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 4;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 = rA0 * rB0;
      rC1_0 = rA1 * rB0;
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC2_3 = rA2 * rB3;
      rC3_3 = rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[1];
      rB0 = *pB0;
      rA1 = pA1[1];
      rA2 = pA2[1];
      rA3 = pA3[1];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[2];
      rB0 = *pB0;
      rA1 = pA1[2];
      rA2 = pA2[2];
      rA3 = pA3[2];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[3];
      rB0 = *pB0;
      rA1 = pA1[3];
      rA2 = pA2[3];
      rA3 = pA3[3];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[4];
      rB0 = *pB0;
      rA1 = pA1[4];
      rA2 = pA2[4];
      rA3 = pA3[4];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[5];
      rB0 = *pB0;
      rA1 = pA1[5];
      rA2 = pA2[5];
      rA3 = pA3[5];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[6];
      rB0 = *pB0;
      rA1 = pA1[6];
      rA2 = pA2[6];
      rA3 = pA3[6];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[7];
      rB0 = *pB0;
      rA1 = pA1[7];
      rA2 = pA2[7];
      rA3 = pA3[7];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[8];
      rB0 = *pB0;
      rA1 = pA1[8];
      rA2 = pA2[8];
      rA3 = pA3[8];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[9];
      rB0 = *pB0;
      rA1 = pA1[9];
      rA2 = pA2[9];
      rA3 = pA3[9];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[10];
      rB0 = *pB0;
      rA1 = pA1[10];
      rA2 = pA2[10];
      rA3 = pA3[10];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[11];
      rB0 = *pB0;
      rA1 = pA1[11];
      rA2 = pA2[11];
      rA3 = pA3[11];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[12];
      rB0 = *pB0;
      rA1 = pA1[12];
      rA2 = pA2[12];
      rA3 = pA3[12];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[13];
      rB0 = *pB0;
      rA1 = pA1[13];
      rA2 = pA2[13];
      rA3 = pA3[13];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[14];
      rB0 = *pB0;
      rA1 = pA1[14];
      rA2 = pA2[14];
      rA3 = pA3[14];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[15];
      rB0 = *pB0;
      rA1 = pA1[15];
      rA2 = pA2[15];
      rA3 = pA3[15];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[16];
      rB0 = *pB0;
      rA1 = pA1[16];
      rA2 = pA2[16];
      rA3 = pA3[16];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[17];
      rB0 = *pB0;
      rA1 = pA1[17];
      rA2 = pA2[17];
      rA3 = pA3[17];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[18];
      rB0 = *pB0;
      rA1 = pA1[18];
      rA2 = pA2[18];
      rA3 = pA3[18];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[19];
      rB0 = *pB0;
      rA1 = pA1[19];
      rA2 = pA2[19];
      rA3 = pA3[19];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[20];
      rB0 = *pB0;
      rA1 = pA1[20];
      rA2 = pA2[20];
      rA3 = pA3[20];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[21];
      rB0 = *pB0;
      rA1 = pA1[21];
      rA2 = pA2[21];
      rA3 = pA3[21];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[22];
      rB0 = *pB0;
      rA1 = pA1[22];
      rA2 = pA2[22];
      rA3 = pA3[22];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[23];
      rB0 = *pB0;
      rA1 = pA1[23];
      rA2 = pA2[23];
      rA3 = pA3[23];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[24];
      rB0 = *pB0;
      rA1 = pA1[24];
      rA2 = pA2[24];
      rA3 = pA3[24];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[25];
      rB0 = *pB0;
      rA1 = pA1[25];
      rA2 = pA2[25];
      rA3 = pA3[25];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[26];
      rB0 = *pB0;
      rA1 = pA1[26];
      rA2 = pA2[26];
      rA3 = pA3[26];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[27];
      rB0 = *pB0;
      rA1 = pA1[27];
      rA2 = pA2[27];
      rA3 = pA3[27];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[28];
      rB0 = *pB0;
      rA1 = pA1[28];
      rA2 = pA2[28];
      rA3 = pA3[28];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[29];
      rB0 = *pB0;
      rA1 = pA1[29];
      rA2 = pA2[29];
      rA3 = pA3[29];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[30];
      rB0 = *pB0;
      rA1 = pA1[30];
      rA2 = pA2[30];
      rA3 = pA3[30];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[31];
      rB0 = *pB0;
      rA1 = pA1[31];
      rA2 = pA2[31];
      rA3 = pA3[31];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[32];
      rB0 = *pB0;
      rA1 = pA1[32];
      rA2 = pA2[32];
      rA3 = pA3[32];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[33];
      rB0 = *pB0;
      rA1 = pA1[33];
      rA2 = pA2[33];
      rA3 = pA3[33];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[34];
      rB0 = *pB0;
      rA1 = pA1[34];
      rA2 = pA2[34];
      rA3 = pA3[34];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[35];
      rB0 = *pB0;
      rA1 = pA1[35];
      rA2 = pA2[35];
      rA3 = pA3[35];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[36];
      rB0 = *pB0;
      rA1 = pA1[36];
      rA2 = pA2[36];
      rA3 = pA3[36];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[37];
      rB0 = *pB0;
      rA1 = pA1[37];
      rA2 = pA2[37];
      rA3 = pA3[37];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[38];
      rB0 = *pB0;
      rA1 = pA1[38];
      rA2 = pA2[38];
      rA3 = pA3[38];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[39];
      rB0 = *pB0;
      rA1 = pA1[39];
      rA2 = pA2[39];
      rA3 = pA3[39];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[40];
      rB0 = *pB0;
      rA1 = pA1[40];
      rA2 = pA2[40];
      rA3 = pA3[40];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[41];
      rB0 = *pB0;
      rA1 = pA1[41];
      rA2 = pA2[41];
      rA3 = pA3[41];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[42];
      rB0 = *pB0;
      rA1 = pA1[42];
      rA2 = pA2[42];
      rA3 = pA3[42];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[43];
      rB0 = *pB0;
      rA1 = pA1[43];
      rA2 = pA2[43];
      rA3 = pA3[43];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[44];
      rB0 = *pB0;
      rA1 = pA1[44];
      rA2 = pA2[44];
      rA3 = pA3[44];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[45];
      rB0 = *pB0;
      rA1 = pA1[45];
      rA2 = pA2[45];
      rA3 = pA3[45];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[46];
      rB0 = *pB0;
      rA1 = pA1[46];
      rA2 = pA2[46];
      rA3 = pA3[46];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[47];
      rB0 = *pB0;
      rA1 = pA1[47];
      rA2 = pA2[47];
      rA3 = pA3[47];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[48];
      rB0 = *pB0;
      rA1 = pA1[48];
      rA2 = pA2[48];
      rA3 = pA3[48];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[49];
      rB0 = *pB0;
      rA1 = pA1[49];
      rA2 = pA2[49];
      rA3 = pA3[49];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[50];
      rB0 = *pB0;
      rA1 = pA1[50];
      rA2 = pA2[50];
      rA3 = pA3[50];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[51];
      rB0 = *pB0;
      rA1 = pA1[51];
      rA2 = pA2[51];
      rA3 = pA3[51];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[52];
      rB0 = *pB0;
      rA1 = pA1[52];
      rA2 = pA2[52];
      rA3 = pA3[52];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[53];
      rB0 = *pB0;
      rA1 = pA1[53];
      rA2 = pA2[53];
      rA3 = pA3[53];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[54];
      rB0 = *pB0;
      rA1 = pA1[54];
      rA2 = pA2[54];
      rA3 = pA3[54];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[55];
      rB0 = *pB0;
      rA1 = pA1[55];
      rA2 = pA2[55];
      rA3 = pA3[55];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[56];
      rB0 = *pB0;
      rA1 = pA1[56];
      rA2 = pA2[56];
      rA3 = pA3[56];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[57];
      rB0 = *pB0;
      rA1 = pA1[57];
      rA2 = pA2[57];
      rA3 = pA3[57];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[58];
      rB0 = *pB0;
      rA1 = pA1[58];
      rA2 = pA2[58];
      rA3 = pA3[58];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[59];
      rB0 = *pB0;
      rA1 = pA1[59];
      rA2 = pA2[59];
      rA3 = pA3[59];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[60];
      rB0 = *pB0;
      rA1 = pA1[60];
      rA2 = pA2[60];
      rA3 = pA3[60];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[61];
      rB0 = *pB0;
      rA1 = pA1[61];
      rA2 = pA2[61];
      rA3 = pA3[61];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[62];
      rB0 = *pB0;
      rA1 = pA1[62];
      rA2 = pA2[62];
      rA3 = pA3[62];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      rA0 = pA0[63];
      rB0 = *pB0;
      rA1 = pA1[63];
      rA2 = pA2[63];
      rA3 = pA3[63];
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pB0 += incBk;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC3[2] = rC2_3;
      pC3[3] = rC3_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK64x64x64TT0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=64, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=4, ku=64, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (60*(lda));
   const float *stN = B + 64;
   const float *pfA = A + M;
   #define incAk 64
   const int incAm = ((((lda) << 2)+lda) - 64), incAn = -(60*(lda));
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 4
   #define incCm 5
   const int incCn = (((ldc) << 2)) - 60;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 = rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 = rA1 * rB0;
         rC2_0 = rA2 * rB0;
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rC4_2 = rA4 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rC3_3 = rA3 * rB3;
         rC4_3 = rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rA2 = pA2[1];
         rA3 = pA3[1];
         rA4 = pA4[1];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rA3 = pA3[2];
         rA4 = pA4[2];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[3];
         rB0 = *pB0;
         rA1 = pA1[3];
         rA2 = pA2[3];
         rA3 = pA3[3];
         rA4 = pA4[3];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rA2 = pA2[4];
         rA3 = pA3[4];
         rA4 = pA4[4];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[5];
         rB0 = *pB0;
         rA1 = pA1[5];
         rA2 = pA2[5];
         rA3 = pA3[5];
         rA4 = pA4[5];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rA2 = pA2[6];
         rA3 = pA3[6];
         rA4 = pA4[6];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[7];
         rB0 = *pB0;
         rA1 = pA1[7];
         rA2 = pA2[7];
         rA3 = pA3[7];
         rA4 = pA4[7];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rA2 = pA2[8];
         rA3 = pA3[8];
         rA4 = pA4[8];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[9];
         rB0 = *pB0;
         rA1 = pA1[9];
         rA2 = pA2[9];
         rA3 = pA3[9];
         rA4 = pA4[9];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[10];
         rB0 = *pB0;
         rA1 = pA1[10];
         rA2 = pA2[10];
         rA3 = pA3[10];
         rA4 = pA4[10];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[11];
         rB0 = *pB0;
         rA1 = pA1[11];
         rA2 = pA2[11];
         rA3 = pA3[11];
         rA4 = pA4[11];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[12];
         rB0 = *pB0;
         rA1 = pA1[12];
         rA2 = pA2[12];
         rA3 = pA3[12];
         rA4 = pA4[12];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[13];
         rB0 = *pB0;
         rA1 = pA1[13];
         rA2 = pA2[13];
         rA3 = pA3[13];
         rA4 = pA4[13];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[14];
         rB0 = *pB0;
         rA1 = pA1[14];
         rA2 = pA2[14];
         rA3 = pA3[14];
         rA4 = pA4[14];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[15];
         rB0 = *pB0;
         rA1 = pA1[15];
         rA2 = pA2[15];
         rA3 = pA3[15];
         rA4 = pA4[15];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[16];
         rB0 = *pB0;
         rA1 = pA1[16];
         rA2 = pA2[16];
         rA3 = pA3[16];
         rA4 = pA4[16];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[17];
         rB0 = *pB0;
         rA1 = pA1[17];
         rA2 = pA2[17];
         rA3 = pA3[17];
         rA4 = pA4[17];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[18];
         rB0 = *pB0;
         rA1 = pA1[18];
         rA2 = pA2[18];
         rA3 = pA3[18];
         rA4 = pA4[18];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[19];
         rB0 = *pB0;
         rA1 = pA1[19];
         rA2 = pA2[19];
         rA3 = pA3[19];
         rA4 = pA4[19];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[20];
         rB0 = *pB0;
         rA1 = pA1[20];
         rA2 = pA2[20];
         rA3 = pA3[20];
         rA4 = pA4[20];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[21];
         rB0 = *pB0;
         rA1 = pA1[21];
         rA2 = pA2[21];
         rA3 = pA3[21];
         rA4 = pA4[21];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[22];
         rB0 = *pB0;
         rA1 = pA1[22];
         rA2 = pA2[22];
         rA3 = pA3[22];
         rA4 = pA4[22];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[23];
         rB0 = *pB0;
         rA1 = pA1[23];
         rA2 = pA2[23];
         rA3 = pA3[23];
         rA4 = pA4[23];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[24];
         rB0 = *pB0;
         rA1 = pA1[24];
         rA2 = pA2[24];
         rA3 = pA3[24];
         rA4 = pA4[24];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[25];
         rB0 = *pB0;
         rA1 = pA1[25];
         rA2 = pA2[25];
         rA3 = pA3[25];
         rA4 = pA4[25];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[26];
         rB0 = *pB0;
         rA1 = pA1[26];
         rA2 = pA2[26];
         rA3 = pA3[26];
         rA4 = pA4[26];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[27];
         rB0 = *pB0;
         rA1 = pA1[27];
         rA2 = pA2[27];
         rA3 = pA3[27];
         rA4 = pA4[27];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[28];
         rB0 = *pB0;
         rA1 = pA1[28];
         rA2 = pA2[28];
         rA3 = pA3[28];
         rA4 = pA4[28];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[29];
         rB0 = *pB0;
         rA1 = pA1[29];
         rA2 = pA2[29];
         rA3 = pA3[29];
         rA4 = pA4[29];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[30];
         rB0 = *pB0;
         rA1 = pA1[30];
         rA2 = pA2[30];
         rA3 = pA3[30];
         rA4 = pA4[30];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[31];
         rB0 = *pB0;
         rA1 = pA1[31];
         rA2 = pA2[31];
         rA3 = pA3[31];
         rA4 = pA4[31];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[32];
         rB0 = *pB0;
         rA1 = pA1[32];
         rA2 = pA2[32];
         rA3 = pA3[32];
         rA4 = pA4[32];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[33];
         rB0 = *pB0;
         rA1 = pA1[33];
         rA2 = pA2[33];
         rA3 = pA3[33];
         rA4 = pA4[33];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[34];
         rB0 = *pB0;
         rA1 = pA1[34];
         rA2 = pA2[34];
         rA3 = pA3[34];
         rA4 = pA4[34];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[35];
         rB0 = *pB0;
         rA1 = pA1[35];
         rA2 = pA2[35];
         rA3 = pA3[35];
         rA4 = pA4[35];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[36];
         rB0 = *pB0;
         rA1 = pA1[36];
         rA2 = pA2[36];
         rA3 = pA3[36];
         rA4 = pA4[36];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[37];
         rB0 = *pB0;
         rA1 = pA1[37];
         rA2 = pA2[37];
         rA3 = pA3[37];
         rA4 = pA4[37];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[38];
         rB0 = *pB0;
         rA1 = pA1[38];
         rA2 = pA2[38];
         rA3 = pA3[38];
         rA4 = pA4[38];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[39];
         rB0 = *pB0;
         rA1 = pA1[39];
         rA2 = pA2[39];
         rA3 = pA3[39];
         rA4 = pA4[39];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[40];
         rB0 = *pB0;
         rA1 = pA1[40];
         rA2 = pA2[40];
         rA3 = pA3[40];
         rA4 = pA4[40];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[41];
         rB0 = *pB0;
         rA1 = pA1[41];
         rA2 = pA2[41];
         rA3 = pA3[41];
         rA4 = pA4[41];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[42];
         rB0 = *pB0;
         rA1 = pA1[42];
         rA2 = pA2[42];
         rA3 = pA3[42];
         rA4 = pA4[42];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[43];
         rB0 = *pB0;
         rA1 = pA1[43];
         rA2 = pA2[43];
         rA3 = pA3[43];
         rA4 = pA4[43];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[44];
         rB0 = *pB0;
         rA1 = pA1[44];
         rA2 = pA2[44];
         rA3 = pA3[44];
         rA4 = pA4[44];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[45];
         rB0 = *pB0;
         rA1 = pA1[45];
         rA2 = pA2[45];
         rA3 = pA3[45];
         rA4 = pA4[45];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[46];
         rB0 = *pB0;
         rA1 = pA1[46];
         rA2 = pA2[46];
         rA3 = pA3[46];
         rA4 = pA4[46];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[47];
         rB0 = *pB0;
         rA1 = pA1[47];
         rA2 = pA2[47];
         rA3 = pA3[47];
         rA4 = pA4[47];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[48];
         rB0 = *pB0;
         rA1 = pA1[48];
         rA2 = pA2[48];
         rA3 = pA3[48];
         rA4 = pA4[48];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[49];
         rB0 = *pB0;
         rA1 = pA1[49];
         rA2 = pA2[49];
         rA3 = pA3[49];
         rA4 = pA4[49];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[50];
         rB0 = *pB0;
         rA1 = pA1[50];
         rA2 = pA2[50];
         rA3 = pA3[50];
         rA4 = pA4[50];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[51];
         rB0 = *pB0;
         rA1 = pA1[51];
         rA2 = pA2[51];
         rA3 = pA3[51];
         rA4 = pA4[51];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[52];
         rB0 = *pB0;
         rA1 = pA1[52];
         rA2 = pA2[52];
         rA3 = pA3[52];
         rA4 = pA4[52];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[53];
         rB0 = *pB0;
         rA1 = pA1[53];
         rA2 = pA2[53];
         rA3 = pA3[53];
         rA4 = pA4[53];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[54];
         rB0 = *pB0;
         rA1 = pA1[54];
         rA2 = pA2[54];
         rA3 = pA3[54];
         rA4 = pA4[54];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[55];
         rB0 = *pB0;
         rA1 = pA1[55];
         rA2 = pA2[55];
         rA3 = pA3[55];
         rA4 = pA4[55];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[56];
         rB0 = *pB0;
         rA1 = pA1[56];
         rA2 = pA2[56];
         rA3 = pA3[56];
         rA4 = pA4[56];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[57];
         rB0 = *pB0;
         rA1 = pA1[57];
         rA2 = pA2[57];
         rA3 = pA3[57];
         rA4 = pA4[57];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[58];
         rB0 = *pB0;
         rA1 = pA1[58];
         rA2 = pA2[58];
         rA3 = pA3[58];
         rA4 = pA4[58];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[59];
         rB0 = *pB0;
         rA1 = pA1[59];
         rA2 = pA2[59];
         rA3 = pA3[59];
         rA4 = pA4[59];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[60];
         rB0 = *pB0;
         rA1 = pA1[60];
         rA2 = pA2[60];
         rA3 = pA3[60];
         rA4 = pA4[60];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[61];
         rB0 = *pB0;
         rA1 = pA1[61];
         rA2 = pA2[61];
         rA3 = pA3[61];
         rA4 = pA4[61];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[62];
         rB0 = *pB0;
         rA1 = pA1[62];
         rA2 = pA2[62];
         rA3 = pA3[62];
         rA4 = pA4[62];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         rA0 = pA0[63];
         rB0 = *pB0;
         rA1 = pA1[63];
         rA2 = pA2[63];
         rA3 = pA3[63];
         rA4 = pA4[63];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pB0 += incBk;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC3[4] = rC4_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK4x64x64TT4x4x64_a1_b0(4, 64, 64, alpha, ca + (60*(lda)), lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
